/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.AWTEvent;
import java.awt.List;

/**
 * Muestra una simple ventana con un error para que el usuario
 * sepa lo que ha pasado. La ventana incluye el traceback de java.
 */
public class DialogoError extends Dialog {
   /**
    * Ajusta/crea todos los elementos grficos.
    * @return Devuelve el panel principal.
    */
   private Panel IniciarDialogo(Exception e) throws Exception {
      this.setLayout(new BorderLayout());
      Panel panel = new Panel(new BorderLayout());
      this.add(panel, BorderLayout.CENTER);

      // Descomentar las lneas comentadas si se tiene el JDK 1.4
//      StackTraceElement[] pilaLlamadas = e.getStackTrace();
      List lista = new List();
      lista.add("Error irrecuperable. Abortando programa.");
      lista.add(new String(e.toString()));
//      for(int f = 0; f < pilaLlamadas.length; f++)
//         lista.add(pilaLlamadas[f].toString());
      panel.add(lista);

      Panel panelBoton = new Panel();
      Button Boton = new Button("Lee!");
      Boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { Boton(e); }});
      panelBoton.add(Boton);
      this.add(panelBoton, BorderLayout.SOUTH);
      return panel;
   }

   /**
    * Constructor del dilogo. Recibe la excepcin que se quiere mostrar
    * al usuario.
    * @param frame Ventana padre.
    */
   public DialogoError(Frame frame, Exception e) {
      super(frame, "ERROR", true);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try {
         add(IniciarDialogo(e));
         pack();
      }
      catch(Exception ex) {
         ex.printStackTrace();
      }
   }

   /**
    * Gestiona los mensajes de la ventana. Simplemente recoge el de
    * cierre de ventana para cancelar la operacin.
    */
   protected void processWindowEvent(WindowEvent e) {
      if (e.getID() == WindowEvent.WINDOW_CLOSING)
         dispose();
      super.processWindowEvent(e);
   }

   /**
    * Llamado cuando el usuario pincha en el botn.
    */
   private void Boton(ActionEvent e) { dispose(); }
}

