/*
 * Proyecto MiCasa, version 1.
 * Copyright (C) 2002 Grzegorz Adam Hankiewicz <gradha@terra.es> y
 * Jon Lpez de Dicastillo <darwater@hotmail.com>.
 * Curso 2001-2002
 * Facultad de Ingeniera
 * Universidad de Deusto
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package MiCasa;

import java.awt.Dialog;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.AWTEvent;
import java.awt.List;

/**
 * Muestra un dilogo para pedirle al usuario el tipo de patrn
 * que desea buscar. El patrn incluye los metacarcteres '*'
 * (cualquier secuencia de cualquier carcter) y '?' (un nico
 * carcter cualquiera).
 */
public class DialogoListadoPatron extends Dialog {
   boolean aceptar = false;
   /** Contiene el patrn */
   TextField patron = new TextField("", 20);

   /**
    * Ajusta/crea todos los elementos grficos.
    * @return Devuelve el panel principal.
    */
   private Panel IniciarDialogo() throws Exception {
      this.setLayout(new BorderLayout());
      Panel panel = new Panel(new BorderLayout());
      this.add(panel, BorderLayout.CENTER);

      panel.add(new Label("Introduzca el patrn de bsqueda"),
         BorderLayout.NORTH);
      panel.add(patron, BorderLayout.CENTER);

      Panel botones = new Panel();
      panel.add(botones, BorderLayout.SOUTH);
      Button boton;
      boton = new Button("Buscar");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonBuscar(e); }});
      botones.add(boton);

      boton = new Button("Cancelar");
      boton.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(ActionEvent e) { BotonCancelar(e); }});
      botones.add(boton);
      
      return panel;
   }

   /**
    * Constructor del dilogo.
    * @param frame Ventana padre.
    */
   public DialogoListadoPatron(Frame frame) {
      super(frame, "Patrn bsqueda", true);
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      try {
         add(IniciarDialogo());
         pack();
      }
      catch(Exception ex) {
         ex.printStackTrace();
      }
   }

   /**
    * Gestiona los mensajes de la ventana. Simplemente recoge el de
    * cierre de ventana para cancelar la operacin.
    */
   protected void processWindowEvent(WindowEvent e) {
      if (e.getID() == WindowEvent.WINDOW_CLOSING)
         dispose();
      super.processWindowEvent(e);
   }

   /**
    * Devuelve el patrn introducido.
    */
   public String Patron() { return patron.getText(); }

   /**
    * Devuelve si se puls el botn de aceptar.
    */
   public boolean Aceptar() { return aceptar; }

   /**
    * Llamado cuando el usuario pincha en el botn de cancelar.
    */
   private void BotonCancelar(ActionEvent e) { dispose(); }

   /**
    * Llamado cuando el usuario pincha en el botn de aceptar.
    */
   private void BotonBuscar(ActionEvent e) { aceptar = true; dispose(); }
}

